// combFilter_RemoveHum.ck
// John Ellinger Music 208 Winter2014

function void playOriginal()
{
	SndBuf buf => dac;
	buf.read( me.sourceDir() + "/wav/StarsNStripesHum.wav" );
	0 => buf.pos;
	// play with hum present
	buf.length() => now;
	buf =< dac;
}

function void playWithHumRemoved()
{
	Impulse imp => dac;
	SndBuf buf;
	buf.read( me.sourceDir() + "/wav/StarsNStripesHum.wav" );

	float out1;
	float out2;
	0 => int n;
	60 => float combF;
	(44100.0/combF) $ int => int delaySamps;
	
	for ( 0 => int n; n < buf.samples(); n++ )
	{
		if ( n < delaySamps )
		{
			buf.valueAt(n) => out1;
			0 => out2;
		}
		else
		{
			buf.valueAt(n) => out1;
			// inverse comb filter, negative buf.valueAt()
			-buf.valueAt( n - delaySamps) => out2;		
		}
		
		out1 + out2 => imp.next;
		
		1::samp => now;
	}
}

playOriginal();
1::second => now;
playWithHumRemoved();
