// fiveTapDecayReverb.ck
// John Ellinger Music 208 Winter2014

/* for COPY PASTE wav file names
music208new.wav
ViolinPizzicato.wav
CelloSolo.wav
*/

Impulse imp => dac => blackhole;

SndBuf buf;
buf.read( me.sourceDir() + "/wav/CelloSolo.wav" );
0 => buf.pos;
float ra[ buf.samples() ];
for ( 0 => int n; n < buf.samples(); n++ )
	buf.valueAt(n) => ra[n];

// Experiment with delay times
(100::ms/samp) $ int => int dly1;
dly1*2 => int dly2;
dly1*3 => int dly3;
dly1*4 => int dly4;
dly1*5 => int dly5;
dly1*6 => int dly6;

// Time Constant Exponential decay
0.8 => float amp;
1.0 => float a1;
Math.fabs( 1 - Math.exp(1.0/2.0) ) => float a2;
Math.fabs( 1 - Math.exp(1.0/3.0) ) => float a3;
Math.fabs( 1 - Math.exp(1.0/4.0) ) => float a4;
Math.fabs( 1 - Math.exp(1.0/5.0) ) => float a5;
Math.fabs( 1 - Math.exp(1.0/6.0) ) => float a6;

float out1;
0 => int n;
ra.cap() => int numSamps;
// play twice
now + 2 * buf.length() => time later;
while ( now < later )
{
	if ( n < dly6 )
	{
		ra[n] => out1;
	}
	else
	{
	amp*(a1*ra[n]+a2*ra[n-dly2]+a3*ra[n-dly3]+a4*ra[n-dly4]+a5*ra[n-dly5]+a6*ra[n-dly6])=>out1;
	}
	
	out1 => imp.next;
	
	1::samp => now;
	
	n++;
	if ( n == numSamps )
		0 => n;
}
